class iaas::profile::nova::common (
  $public_interface = hiera('iaas::public_interface', undef),
  $admin_interface = hiera('iaas::admin_interface', undef),

##verbose, debug
  $verbose = hiera('iaas::verbose', undef),
  $debug = hiera('iaas::debug', undef),

  $default_flotting_pool = undef,
  $neutron_password = hiera('iaas::profile::neutron::password', undef),
  $nova_password = hiera('iaas::profile::nova::controller::password', undef),

  $region = hiera('iaas::region', undef),
#VIP1
  $endpoint_main = hiera('iaas::main_address', undef),
#VIP2
  $endpoint_admin = hiera('iaas::admin_address', undef),
##rhosts
  $endpoint = hiera('iaas::main_address', undef),
  $rhosts = hiera('iaas::profile::rabbitmq::rhosts', undef),
  $rabbitmq_user = hiera('iaas::profile::rabbitmq::user', undef),
  $rabbitmq_password = hiera('iaas::profile::rabbitmq::password', undef),

# Memcache
  $memcache = hiera('iaas::memcache::coordination', false),
) {
  include iaas::resources::connectors

  class { '::nova':
    verbose => $verbose,
    debug => $debug,
    database_connection => $iaas::resources::connectors::nova,
    glance_api_servers => [ "${endpoint_admin}:9292" ],
##rabbit_hosts - uncomment as needed
#    rabbit_host => $endpoint,
    rabbit_hosts => $rhosts,
    rabbit_userid => $rabbitmq_user,
    rabbit_password => $rabbitmq_password,
    mysql_module => '2.3',
    database_idle_timeout => 3600,
# Memcache1.1.0
    memcached_servers => $memcache,
  }

  class { '::nova::network::neutron':
    neutron_admin_password => $neutron_password,
    neutron_region_name => $region,
    neutron_admin_auth_url => "http://${endpoint_admin}:35357/v2.0",
    neutron_url => "http://${endpoint_admin}:9696",
  }

# Set VNC host
  class { '::nova::vncproxy::common':
    vncproxy_host => $endpoint_main,
  }

  nova_config { 
   'DEFAULT/default_floating_pool': value => $default_flotting_pool;
   'DEFAULT/my_ip': value => $::facts["ipaddress_${admin_interface}"];
   'keystone_authtoken/identity_uri' :value => "http://${endpoint_admin}:35357";
  }

}
